Skip to main content
`Ctrl`+`K`

# DENSsolutions formats

RosettaSciIO can read any logfile from DENSsolutions’ new Impulse software as well as the legacy heating software DigiHeater.

## DENSsolutions Impulse logfile

Impulse logfiles are stored in `.csv` format. All metadata linked to the experiment is stored in a separate `metadata.log` file. This metadata file contains crucial information about the experiment and should be included in the same folder with the `.csv` file when reading data using RosettaSciIO.

Note

To read Impulse logfiles in HyperSpy, use the `reader` argument to define the correct file plugin as the `.csv` extension is not unique to this reader:

    >>> import hyperspy.api as hs
    >>> hs.load("filename.csv", reader="impulse")

### API functions

rsciio.impulse.file_reader(filename, lazy=False)

  Read a DENSsolutions Impulse logfile.

  Parameters:
    filename `python:str`, `pathlib.Path`

      Filename of the file to read or corresponding pathlib.Path.

    lazy bool, default=False

      Lazy loading is not supported.

  Returns:
    `python:list` of `python:dict`

      List of dictionaries containing the following fields:

      - ‘data’ – multidimensional `numpy.ndarray` or `dask.array.Array`

      - ‘axes’ – list of dictionaries describing the axes containing the fields ‘name’, ‘units’, ‘index_in_array’, and either ‘size’, ‘offset’, and ‘scale’ or a numpy array ‘axis’ containing the full axes vector

      - ‘metadata’ – dictionary containing the parsed metadata

      - ‘original_metadata’ – dictionary containing the full metadata tree from the input file

      When the file contains several datasets, each dataset will be loaded as separate dictionary.

## DENSsolutions DigiHeater logfile

RosettaSciIO can read the heater log format from the DENSsolutions’ DigiHeater software. The format stores all the captured data for each timestamp, together with a small header in a plain-text format. The reader extracts the measured temperature along the time axis, as well as the date and calibration constants stored in the header.

### API functions

rsciio.dens.file_reader(filename, lazy=False)

  Read a DENSsolutions DigiHeater logfile.

  Parameters:
    filename `python:str`, `pathlib.Path`

      Filename of the file to read or corresponding pathlib.Path.

    lazy bool, default=False

      Lazy loading is not supported.

  Returns:
    `python:list` of `python:dict`

      List of dictionaries containing the following fields:

      - ‘data’ – multidimensional `numpy.ndarray` or `dask.array.Array`

      - ‘axes’ – list of dictionaries describing the axes containing the fields ‘name’, ‘units’, ‘index_in_array’, and either ‘size’, ‘offset’, and ‘scale’ or a numpy array ‘axis’ containing the full axes vector

      - ‘metadata’ – dictionary containing the parsed metadata

      - ‘original_metadata’ – dictionary containing the full metadata tree from the input file

      When the file contains several datasets, each dataset will be loaded as separate dictionary.